// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* ̧			: USI_TWI_Slave.c
* ߲		: IAR EWAAVR 4.11A
* 			: $Revision: 614 $
* t			: $Date: 2006-07-07 10:27:05 +0200 (Fri, 07 Jul 2006) $
* XV		: $Author: jllassen $
*
* xҰ		: avr@atmel.com
*
* x޲	: USIgp\ȑS޲
*
* pLq		: AVR312 - I2C]uƂĂUSI̎g
*
* 			: USI_TWIMUSI_TWIMp̊֐
*
****************************************************************************/

#include "config.h"
#include "USI_TWI_Slave.h"

/*! ÓIϐ
 */

static unsigned char TWI_slaveAddress;
static volatile unsigned char USI_TWI_Overflow_State;


/*! Ǐϐ
 */
static uint8_t TWI_RxBuf[TWI_RX_BUFFER_SIZE];
static volatile uint8_t TWI_RxHead;
static volatile uint8_t TWI_RxTail;

static uint8_t TWI_TxBuf[TWI_TX_BUFFER_SIZE];
static volatile uint8_t TWI_TxHead;
static volatile uint8_t TWI_TxTail;

/*! \brief TWIɏՕj
 */
void Flush_TWI_Buffers(void)
{
  TWI_RxTail = 0;
  TWI_RxHead = 0;
  TWI_TxTail = 0;
  TWI_TxHead = 0;
}

//********** USI_TWI֐ **********//

/*! \brief
 * TWI]upUSI
 */
void USI_TWI_Slave_Initialise( unsigned char TWI_ownAddress )
{
  Flush_TWI_Buffers();								// MɏՕ
  TWI_slaveAddress = TWI_ownAddress;				// ]uڽ

  PORT_USI |=  (1<<PORT_USI_SCL);					// SCL=Jlw
  PORT_USI |=  (1<<PORT_USI_SDA);					// SDA=Jlw
  DDR_USI  |=  (1<<PORT_USI_SCL);					// SCLo͐ݒ
  DDR_USI  &= ~(1<<PORT_USI_SDA);					// SDA͐ݒ
  USICR    =  (1<<USISIE)|(0<<USIOIE)|				// Jn荞݋,vꊄ荞݋֎~(JnȑǑvꊄ荞݂͐ݓIɎs)
			  (1<<USIWM1)|(0<<USIWM0)|				// 2ݒ(vSCLێȂ)
			  (1<<USICS1)|(0<<USICS0)|(0<<USICLK)|	// Oۯ㏸[Đݒ
			  (0<<USITC);
  USISR    = 0xF0;									// S׸މ(0),vؾ
}

/*! \brief MɏՕ޲ ްi[(ɏՕ󂫑ҋ@)
*/
void USI_TWI_Transmit_Byte( unsigned char byte_data )
{
  unsigned char tmphead;

  tmphead = ( TWI_TxHead + 1 ) & TWI_TX_BUFFER_MASK;	// ɏՕ݈ʒu擾
  while ( tmphead == TWI_TxTail );						// ɏՕ󂫗LmF(ҋ@)
  TWI_TxBuf[tmphead] = byte_data;						// ɏՕްi[
  TWI_TxHead = tmphead;									// MɏՕ݈ʒuwqXV
}

/*! \brief MɏՕ޲ ް擾(ްҋ@)
 */
unsigned char USI_TWI_Receive_Byte( void )
{
  unsigned char tmptail;
  unsigned char tmpRxTail;								// volatileLpꎞϐ

  tmpRxTail = TWI_RxTail;								// {IɕsvAxh~p
  while ( TWI_RxHead == tmpRxTail );					// ɏՕްL܂őҋ@
  tmptail = ( TWI_RxTail + 1 ) & TWI_RX_BUFFER_MASK;	// ɏՕǂݍ݈ʒu擾
  TWI_RxTail = tmptail;									// MɏՕǂݍ݈ʒuwqXV
  return TWI_RxBuf[tmptail];							// ɏՕ޲ ްƋɕA
}

/*! \brief MɏՕްL
 */
unsigned char USI_TWI_Data_In_Receive_Buffer( void )
{
  unsigned char tmpRxTail;								// volatileLpꎞϐ

  tmpRxTail = TWI_RxTail;								// {IɕsvAxh~p
  return ( TWI_RxHead != tmpRxTail );					// MɏՕ(ŋU)ƋɕA
}

/*! \brief USIJn荞ݏٰ
 * USI_TWIJnoAUSITWIڽ ߹ĎMɏB
 */
#ifdef __GNUC__
  ISR(USI_START_vect)
#else
#pragma vector=USI_START_VECTOR
__interrupt void USI_Start_Condition_ISR(void)
#endif
{
  unsigned char tmpUSISR;								// volatileLpꎞϐ

  tmpUSISR = USISR;										// {IɕsvAxh~p
  USI_TWI_Overflow_State = USI_SLAVE_CHECK_ADDRESS;		// Ԕԍ(=ڽ)
  DDR_USI  &= ~(1<<PORT_USI_SDA);						// SDA͐ݒ
  while ( (PIN_USI & (1<<PORT_USI_SCL)) & !(tmpUSISR & (1<<USIPF)) );	// SCL܂͒~ҋ@
														// SCL͊Jnۏ؂邽߂̑҂
														// ~SCLȂł̖ҋ@p
  USICR   =   (1<<USISIE)|(1<<USIOIE)|					// Jnƌv̗荞݋(Jn荞݂͍đJnp)
			  (1<<USIWM1)|(1<<USIWM0)|					// 2ݒ(vꎞSCL=Lێt)
			  (1<<USICS1)|(0<<USICS0)|(0<<USICLK)|		// Oۯ㏸[Đݒ
			  (0<<USITC);
  USISR  =    (1<<USI_START_COND_INT)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|	// S׸މ(0)
			  (0x0<<USICNT0);							// USIv8ޯĂɐݒ
}

/*! \brief USIvꊄ荞ݏٰ
 * SĂ̒ʐM̏BVKJnҋ@֎~܂B
 */
#ifdef __GNUC__
  ISR(USI_OVF_vect)
#else
#pragma vector=USI_OVERFLOW_VECTOR
__interrupt void USI_Counter_Overflow_ISR(void)
#endif
{
  unsigned char tmpTxTail;								// volatileLpꎞϐ
  unsigned char tmpUSIDR;


  switch (USI_TWI_Overflow_State)
  {
	/* ڽ */
	case USI_SLAVE_CHECK_ADDRESS:							/* ڽ */
	  if ((USIDR == 0) || (( USIDR>>1 ) == TWI_slaveAddress))	// ČĂяoڽwŁA
	  {
		if ( USIDR & 0x01 )										// 呕uǂݍݓ(R/W=1)ŁA
		  USI_TWI_Overflow_State = USI_SLAVE_SEND_DATA;			// ԔԍްMԂɐݒ
		else													// 呕uݓ(R/W=0)ŁA
		  USI_TWI_Overflow_State = USI_SLAVE_REQUEST_DATA;		// ԔԍްMԂɐݒ
		  SET_USI_TO_SEND_ACK();									// USIACKMݒ
	  }
	  else														// ČĂяoƎڽwȊOŁA
	  {
		SET_USI_TO_TWI_START_CONDITION_MODE();					// USIVKJnҋ@ݒ
	  }
	  break;
	/* 呕uްǂݍݓ쏈 */
	case USI_SLAVE_CHECK_REPLY_FROM_SEND_DATA:				/*  */
	  if ( USIDR )												// NACK(呕uI錾)MŁA
	  {
		SET_USI_TO_TWI_START_CONDITION_MODE();					// USIVKJnҋ@ݒ
		return;
	  }															// (ACKMŎްMԂs)
	case USI_SLAVE_SEND_DATA:								/* ްM */
	  tmpTxTail = TWI_TxTail;									// {IɕsvAxh~p
	  if ( TWI_TxHead != tmpTxTail )							// MɏՕްLŁA
	  {
		TWI_TxTail = ( TWI_TxTail + 1 ) & TWI_TX_BUFFER_MASK;	// MɏՕǂݍ݈ʒu擾,ʒuwqXV
		USIDR = TWI_TxBuf[TWI_TxTail];							// ɏՕΉ޲ ްUSIDRɐݒ
	  }
	  else														// MɏՕްȂŁA
	  {
		SET_USI_TO_TWI_START_CONDITION_MODE();					// USIVKJnҋ@ݒ
		return;
	  }
	  USI_TWI_Overflow_State = USI_SLAVE_REQUEST_REPLY_FROM_SEND_DATA;	// ԔԍMɐݒ
	  SET_USI_TO_SEND_DATA();									// USI8ޯ ްMݒ
	  break;
	case USI_SLAVE_REQUEST_REPLY_FROM_SEND_DATA:			/* M */
	  USI_TWI_Overflow_State = USI_SLAVE_CHECK_REPLY_FROM_SEND_DATA;	// ԔԍԂɐݒ
	  SET_USI_TO_READ_ACK();									// USIMݒ
	  break;
	/* 呕uްݓ쏈 */
	case USI_SLAVE_REQUEST_DATA:							/* ްM */
	  USI_TWI_Overflow_State = USI_SLAVE_GET_DATA_AND_SEND_ACK;	// ԔԍMԂɐݒ
	  SET_USI_TO_READ_DATA();									// USI8ޯ ްMݒ
	  break;
	case USI_SLAVE_GET_DATA_AND_SEND_ACK:					/* M */
	  tmpUSIDR = USIDR;											// {IɕsvAxh~p
	  TWI_RxHead = ( TWI_RxHead + 1 ) & TWI_RX_BUFFER_MASK;		// MɏՕ݈ʒu擾,ʒuwqXV
	  TWI_RxBuf[TWI_RxHead] = tmpUSIDR;							// MɏՕɎM޲Ċi[
	  USI_TWI_Overflow_State = USI_SLAVE_REQUEST_DATA;			// ԔԍްMԂɐݒ
	  SET_USI_TO_SEND_ACK();									// USIACKMݒ
	  break;
  }
}
